{ Programa para tocar arquivos de som e CDPlayer   }
{ Autor : Marcelo Luis Pimentel  }
{         e Jos Antonio Borges  }
{ Em 5/3/98 }

Program MidiaVox;

uses
  dvcrt,
  dvwin,
  dvArq,
  dvForm,
  winprocs,
  wintypes,
  sysUtils,
  mmsystem;

var
    dispAberto: boolean;
    opcao : char;
    trilhas, trilhaAtual : integer;
    ret : longInt;
    nomeDisp : string;
    retorno: array [0..512] of char;
    avancoBasico: integer;

procedure Ajuda;
begin
  writeln ('As opes so: ');
  sintSom ('MIASOPC');
  writeln('    A - Toca um arquivo Multi-Midia');
  writeln('    C - Acionar CD-Player');
  writeln('    T - Toca arquivo atual');
  writeln('    F - Fim do Midiavox');

  sintsom('MIAJUDA');
end;

function acertaNome (nomeArq: string): string;
begin
    acertaNome := '';
    nomeArq := trim (nomeArq);
    if nomeArq = '' then exit;

    if pos (' ', nomeArq) <> 0 then
        nomeArq := '"' + nomeArq + '"';

    acertaNome := nomeArq;
end;

{  envia comando MCI para Windows processar }

Function EnviaComandoMCI (cmd : string) : LongInt;
var
    comando : array [0..512] of char;
    erro: longint;
begin
    strPCopy (comando, cmd);
    erro := mciSendString(comando, retorno, 512, 0);
    EnviaComandoMCI := erro;
    keypressed;
end;

{  erro no MCI  }

Procedure erroMCI (qualErro : longInt);
var
    retPas : string;
begin
    mciGetErrorString(qualErro, retorno, 255); 
    sintsom ('MIERRMCI');
    retPas := strPas (retorno);
    sintWriteln (retPas);
end;

{  transforma retorno MCI em inteiro }

function pegaRetornoMci: longint;
var valor: longint;
    erro: integer;
begin
    val (strPas (retorno), valor, erro);
    pegaRetornoMci := valor;
end;

{    seleciona dispositivo a usar }

procedure EscolheDispositivo;
begin
    enviaComandoMCI ('close disp1');

    If nomedisp = ''  Then
        begin
            writeln ('Informe nome do arquivo : ');
            sintsom ('MIDIGNOM');
            garanteEspacoTela(7);
            nomedisp := obtemNomeArq(7);
            writeln (nomedisp);
            nomedisp := acertaNome (nomedisp);
            If nomedisp = ''  then
                begin
                    sintsom('MIDESIST');
                    dispAberto := false;
                    exit;
                end;
            setWindowTitle ('Midiavox - ' + nomeDisp);
        end;

    if maiuscAnsi (copy (nomeDisp, length(nomeDisp)-2, 3)) = 'MID' then
        avancoBasico := 2
    else
        avancoBasico := 2000;

    ret := enviaComandoMCI ('open ' + nomedisp + ' alias disp1');
    dispAberto := ret = 0;

    if dispAberto  Then
        begin
            If opcao <> #30  Then
                sintSom ('MIOK');
            enviaComandoMCI ('set unidcd time format tmsf');
        end
    Else
        begin
            nomeDisp := '';
        end;
end;

{    acionamento do cdplayer    }

procedure CDPlayer;

    procedure ajudaCDPlayer;
    begin
    writeln;
    writeln ('As opcoes do CD-Player so : ');
    sintSom ('MIOPCCDP');
    writeln ('  L - Liga o CD-Player      D - Desliga o CD-Player');
    writeln ('  V - Volta msica          A - Avana msica');
    writeln ('  R - Repetir msica        P - Pausa msica');
    writeln ('  E - abre gaveta do CD     F - fecha gaveta do CD');
    writeln ('  N - escolher msica       I - Informaes sobre o dispositivo');
    writeln ('  S - estatisticas gerais   ESC - fim');
    sintsom ('MIAJUCDP');
    end;

var
    op : char;
    faixa : string;
    i: integer;
    unidCD: string;

label pula, executa;

begin
  writeln;
  unidCD := sintAmbiente ('MIDIAVOX', 'CD');
  if unidCD <> '' then
      enviaComandoMCI ('open ' + unidcd + ':\ type cdaudio alias unidcd')
  else
      enviaComandoMCI ('open cdaudio alias unidcd');

  ret := enviaComandoMCI ('status unidcd ready');
  if strPas (retorno) = 'false' then
    begin
    writeln ('O CD-Player no est preparado.');
    sintSom ('MINAOACH');
    end;

  enviaComandoMCI ('set unidcd time format tmsf');

  repeat
  textBackground (RED);
  write ('Qual a opo do CDPlayer ? ');
  textBackground (BLACK);

  sintsom ('MIQOPCDP');
  op := sintReadKey;
  writeln (op);
  op := upcase (op);
  delay (500);

executa:

  ret := 0;
  case op of

    'L', 'T', ^m: begin
                  enviaComandoMCI ('play unidcd');
              end;

    'D' :       ret := enviaComandoMCI ('stop unidcd');

    ' ', 'P' :  ret := enviaComandoMCI ('pause unidcd');

    'E' :   { abre porta }
                 ret := enviaComandoMCI ('set unidcd door open');

    'F' :   { fecha porta }
             begin
                   ret := enviaComandoMCI ('set unidcd door closed');
                   enviaComandoMCI ('status unidcd number of tracks');
                   sintWriteln (strPas(retorno) + ' trilhas');
             end;

    'A' : begin    { avanar faixa }
             enviaComandoMCI ('status unidcd number of tracks');
             trilhas := pegaRetornoMCI;
             enviaComandoMCI ('status unidcd current track');
             trilhaAtual := pegaRetornoMCI + 1;

             enviaComandoMCI ('stop unidcd');
             if trilhaAtual <= trilhas then
                 begin
                     str (trilhaAtual, faixa);
                     ret := enviaComandoMCI ('play unidcd from '+ faixa);
                 end;
        end;

    'V' : begin     { voltar faixa }
             enviaComandoMCI ('status unidcd current track');
             trilhaAtual := pegaRetornoMCI - 1;
             enviaComandoMCI ('stop unidcd');
             if trilhaAtual > 0 then
                 begin
                     str (trilhaAtual, faixa);
                     enviaComandoMCI ('play unidcd from '+ faixa);
                 end;
         end;

    'R' : begin   { repetir faixa }
                enviaComandoMCI ('status unidcd current track');
                faixa := strPas (retorno);
                enviaComandoMCI ('stop unidcd');
                enviaComandoMCI ('play unidcd from '+ faixa);
            end;

    'N' :  begin
              ret := enviaComandoMCI ('stop unidcd');
              write ('Informe o nmero da faixa : ');
              sintSom ('MIINFNUM');
              sintReadln (faixa);
              enviaComandoMCI ('play unidcd from ' + faixa);
           end;

    'I':   begin
               enviaComandoMCI ('status unidcd ready');
               if strPas (retorno) <> 'true' then
                   begin
                       writeln ('O CD-Player no est preparado.');
                       sintSom ('MINAOACH');
                       goto pula;
                   end;

               enviaComandoMCI ('status unidcd number of tracks');
               sintWrite ('Nmero de trilhas   ');
               sintWriteint (pegaRetornoMCI);
               writeln;

               enviaComandoMCI ('status unidcd current track');
               sintWrite ('Trilha corrente     ');
               sintWriteint (pegaRetornoMCI);
               enviaComandoMCI ('status unidcd length track ' + strPas (retorno));
               sintWrite (' com durao de ');
               sintWriteln (strPas (retorno));
           end;

    'S':   begin
               enviaComandoMCI ('status unidcd ready');
               if strPas (retorno) <> 'true' then
                   begin
                       writeln ('O CD-Player no est preparado.');
                       sintSom ('MINAOACH');
                       goto pula;
                   end;

               sintWriteln ('Durao das trilhas');
               enviaComandoMCI ('status unidcd number of tracks');
               trilhas := pegaRetornoMCI;

               for i := 1 to trilhas do
                   begin
                       str (i, faixa);
                       enviaComandoMCI ('status unidcd length track ' + faixa);
                       sintWriteInt (i);
                       write ('   ');
                       sintWriteln (strPas(retorno));
                       if keypressed then break;
                   end;
               writeln;
           end;


    #27 : sintSom ('MIDESIST');

    Else
        begin
            while keypressed do readkey;
            ajudacDPlayer;
        end;
    End; { case }

    if op in ['L', 'T', 'R', 'V', 'A', 'N', ^m] then
       begin
             enviaComandoMCI ('set unidcd time format tmsf');
             repeat
                  ret := enviaComandoMCI ('status unidcd position');
                  write (strPas(retorno), #$0d);
                  delay (100);
             until keypressed;
             op := upcase(readkey);
             writeln;
             goto executa;
       end;

pula:

  until op = #27;
  enviaComandoMCI ('close unidcd');
end;

{   aciona tocador de som  }

{-------------------------------------------------------------}
{                   aciona o tocador
{-------------------------------------------------------------}

procedure AcionaTocador;
var cmdTecla : char;
    tocando: boolean;


      {-------------------------------------------------------------}

      procedure avancaSom;
      var s: string;
          p: longint;
      begin
          enviaComandoMci ('pause disp1');
          enviaComandoMci ('status disp1 position');
          p := pegaRetornoMci;
          p := p + avancoBasico;
          str (p, s);
          enviaComandoMci ('seek disp1 to ' + s);
          enviaComandoMci ('play disp1');
      end;

      {-------------------------------------------------------------}

      procedure recuaSom;
      var p: longint;
          s: string;
      begin
          enviaComandoMci ('pause disp1');
          enviaComandoMci ('status disp1 position');
          p := pegaRetornoMci;
          p := p - avancoBasico;
          if p < 0 then p := 0;
          str (p, s);
          enviaComandoMci ('seek disp1 to ' + s);
          enviaComandoMci ('play disp1');
      end;

      {-------------------------------------------------------------}

label toca, pausa;

begin

  If not dispAberto  then
    begin
    writeln('O dispositivo no est acessvel.');
    sintsom ('MIDISNAO');
    nomeDisp := '';
    exit;
    end;

  ret := enviaComandoMCI ('play disp1 from 1');
  If ret <> 0  then
    begin
    erroMCI (ret);
    exit;
    end;

  writeln ('Comandos:  espao - pausa/toca  tab - repete  esc - termina');
  writeln ('Direita - avana   Esquerda - recua    Cima - toca  Baixo - pausa');
  writeln ('Home - incio    End - fim');

  tocando := true;
  repeat
      cmdTecla := upcase(readKey);
      case cmdTecla of
          #27 : ret := enviaComandoMCI  ('stop disp1');

          ' ', ENTER:
            if tocando then
                begin
pausa:
                    ret := enviaComandoMCI ('pause disp1');
                    tocando := false;
                end
            else
                begin
toca:
                   ret := enviaComandoMCI ('play disp1');
                   tocando := true;
                end;

        TAB   : begin
                    enviaComandoMCI ('play disp1 from 1');
                    tocando := true;
                end;

        #$0:   case readkey of
            F1    : begin
                        if tocando then
                            begin
                                ret := enviaComandoMCI ('pause disp1');
                                tocando := false;
                            end;
                         sintSom ('MIAJUOPC');
                     end;

            DIR:  avancaSom;
            ESQ:  recuaSom;
            CIMA: goto toca;
            BAIX: goto pausa;
            HOME: begin
                    enviaComandoMci ('pause disp1');
                    enviaComandoMci ('seek disp1 to 0');
                  end;
            TEND: begin
                    enviaComandoMci ('pause disp1');
                    enviaComandoMci ('seek disp1 to end');
                  end;
            end;

    End;

    until cmdTecla = #27;
  sintSom ('MIOK');
end;

{   fala status atual   }

procedure statusDispositivo;
begin
  writeln;
  write ('Estado do dispositivo : ');
  sintsom ('MISTATUS');

  ret := enviaComandoMCI ('info disp1');
  If ret <> 0  Then
    begin
    if strLen (retorno) <> 0 then
        sintWriteln ( strPas(retorno))
    else
        begin
            writeln ('OK');
            sintSom ('MIOK');
        end;
  end;

    writeln;
    end;


begin
  checkbreak := false;
  screensize.y := 12;
  clrscr;
  textBackground (BLUE);
  Writeln ('M I D I A V O X  -  Acionador Multimdia');
  textBackground (BLACK);
  sintInic (0, sintAmbiente ('MIDIAVOX', 'DIRMIDIAVOX'));

  If paramCount > 0  Then
    begin
        nomedisp := paramStr(1);
        nomedisp := acertaNome (nomedisp);
        opcao := #30;
        setWindowTitle ('Midiavox - ' + nomeDisp);
    end
  Else
    begin
        opcao := ' ';
        nomedisp := '';
        setWindowTitle ('Midiavox');
        sintsom ('MINICIAL');
    end;

  dispAberto := false;

  repeat
    writeln;

    If opcao <> #30  then
      begin
      setWindowTitle ('Midiavox');
      textBackground (BLUE);
      write ('Midiavox - qual a opo ? ');
      textBackground (BLACK);
      sintSom ('MIQUALOP');
      opcao := upCase (sintReadkey);
      writeln(opcao);
      end;

    case opcao of

      #30 : begin
            EscolheDispositivo;
            acionaTocador;
            opcao := 'F';
            end;

      'A' : begin
            nomeDisp := '';
            escolheDispositivo;
            AcionaTocador;
            end;

      'T' : acionaTocador;

      'C' : CDPlayer;

      'F', #27 : sintSom ('MIFINAL');

      'I' : StatusDispositivo;
    Else
        begin
            while keypressed do readkey;
            ajuda;
        end;
      end;

    until opcao in ['F', #27];

    If dispAberto  then
        ret := enviaComandoMCI ('close disp1');
    sintfim;
    doneWinCrt;
end.
